module Picard_11_Data_Types where


type QInterval = (Rational, Rational)
type QRec      = (QInterval,QInterval)
type QRecs     = [QRec]
type QCube     = (QInterval,QInterval,QInterval)
type QCubes    = [QCube]
--
data QStep     = QINotDef QInterval | QIFail QInterval |
                 QIDef (QInterval,QInterval,QInterval)
                 deriving(Eq,Show)
type QSteps    = [QStep]
--
data Carried   = CarryN | CarryY Rational Rational
                 deriving(Eq,Show)



-------------------------------------------------------------------------------
-- Q1Dpoint    - rational number in R
-- Q2Dpoint    - a rational point in R^2
-- Q1Dinterval - 
-- QRec        - represents a rational rectange. The first interval represents
--               a projection of a rectangle on the x axis, while the second
--               interval represents the y side.
-------------------------------------------------------------------------------
{--
type Q1Dpoint     = Rational
type Q2Dpoint     = (Rational, Rational)
type Q1Dinterval  = (Q1Dpoint, Q1Dpoint)
type QRec         = (Q1Dinterval, Q1Dinterval)
type QCube        = (Q1Dinterval, Q1Dinterval, Q1Dinterval)
--}


-------------------------------------------------------------------------------
-- QCFunction  - stands for rational classical function, i.e. a classical
--               function which is piecewise linear with rational end-points.
-- QCNotDef x  - means that a function is not defined over an interval
--               x=(x1,x2)
-- QCFail x    - means that something is wrong with a function over an interval
--               x=(x1,x2)
-- QCDef (x,y) - represents a line (x1,y1)-(x2,y2), with x=(x1,x2), y=(y1,y2)
-------------------------------------------------------------------------------
{--
data QCFunction_1 = QCNotDef Q1Dinterval | QCFail Q1Dinterval |
                    QCDef (Q1Dinterval, Q1Dinterval)
                    deriving (Show)
type QCFunction   = [QCFunction_1]
--}


-------------------------------------------------------------------------------
-- QIFunction      - stands for rational interval function. Every point in a
--                   domain is mapped to an interval. End-points of all
--                   intervals are rational numbers
-- QINotDef x      - function is not defined over the interval
--                   x=(x1,x2)
-- QIFail x        - something is wrong with the function over the interval
--                   x=(x1,x2)
-- QIDef (x,yL,yU) - represents a strip defined over the interval x=(x1,x2)
--                   bounded by lines (x1,yL1)-(x2,yL2) (this represents
--                   lower bound) and (x1,yU1)-(x2,yU2) (upper bound), where
--                   yL=(yL1,yL2), yU=(yU1,yU2)
-------------------------------------------------------------------------------
{--
data QIFunction_1 = QINotDef Q1Dinterval | QIFail Q1Dinterval |
                    QIDef (Q1Dinterval, Q1Dinterval, Q1Dinterval)
                    deriving (Eq,Show)
type QIFunction   = [QIFunction_1]
--}



